# -*- coding: utf-8 -*-
"""
Created on Sat Feb 16 13:40:41 2019

@author: Oriol Solé

Programa versió1: Enviament d'imatges automàtic (Programa modem receptor)
"""

#Llibreries####################################################################

#Importacio de les llibreries adients:
import base64   #Llibreria per codificar i descodificar les imatges en base 64
import socket   #Llibreria per fer ús dels sockets
import time     #Llibreria per manipular tasques relacionades amb temps
import datetime #Llibreria per obentir dates
import os       #Llibreria per manipular paths
import sys      #Llibreria per executar instruccions amb permis del sistema

#Configuració Modems###########################################################

#Definicio de les IPs i dels ports de comunicació dels modems acustics físics 
#i virtuals receptors
HOSTNAME2EM = '10.42.57.3'
HOSTNAME2 = '192.168.1.197'
PORT2 = 9200

#Classe funcions sockets#######################################################

#Creacio de la classe netcat per ubicar les funcions relatives a la manipulacio
#dels sockets
class netcat(object):
#Definició de la funció inicial per la configuració del mòdem acústic
  def __init__ (self,hostname,port,modem_name):
        #Establiment de la ip, el port de comunicació i el nom del mòdem
        self.ip = hostname
        self.port = port
        self.name = modem_name
        #Creació del socket i connectivitat
        try:
            self.netcat = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.netcat.settimeout(0.1)
            self.netcat.connect((self.ip, self.port))
        except:
            print ("El programa es tancara, ja que no s'ha pogut establir"+
            " una connexio degut a que el sistema no esta alimentat, connecti"+
            " la alimentacio i executi de nou el programa")
            time.sleep(5)
            sys.exit(1)
        
        #Configuracions inicials:
        print 'Activacio permissos'
        self.send('AT@CTRL')
        print 'Desactivacio notificacions extesses'
        self.send('AT@ZX0')
        print 'Desactivacio notificacions de posicionament'
        self.send('AT@ZU0')
        print 'Reiniciament del buffer de transmissio:'
        self.send('ATZ4')
        print 'Configuracio del numero de bytes del buffer de transmissio:'
        self.send('AT@ZL1000000')
        print 'Guardar en memoria les configuracions del modem'
        self.send('AT&W') 
    
  #Funció de lectura de dades 
  def port_read(self):
        buff = ''
        read = ""
        while 1:
            #Bloc d'excepcio, en cas de no poder establir connectivitat, i que
            #no es tracti d'un error de timeout, es torna a intentar restablir
            #la connexio perduda
            try:
                read = self.netcat.recv(1)
            except socket.error as error:
                if str(error) != "timed out":
                    print ("El programa es tancara degut a un problema amb"+
                    " la alimentacio, comprovala i executa de nou el programa")
                    time.sleep(5)
                    sys.exit(1)
                    break
                break
            if read:
                buff += read
            else:
                break  
        return buff
            
  #Funció per escriptura de comandes AT
  def port_write(self,command):
    while 1:
        print 'Send',self.name +':',command
        try:
            self.netcat.sendall(command + '\n')
            break
        except:
            try:
                self.netcat = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                self.netcat.settimeout(0.1)
                self.netcat.connect((self.ip, self.port))
                print "Connexio recuperada"
            except:
                print "Intent de connexio fallit"
                time.sleep(2)
                pass
    return

  #Funció d'enviament de comandes AT amb comprovació de resposta
  def send(self,command):
     while 1:
            self.port_write(command)
            read = self.port_read()
            x1 = read.find("BUSY CLOSING CONNECTION")
            x2 = read.find("FAILED")
            x3 = read.find("OK")
            if x1!=-1:
                print "Received", self.name + ':', "FAILED"
            elif x2!=-1:
                print "Received",self.name + ':', "BUSY CLOSING CONNECTION"
            elif x3!=-1: 
                print "Received",self.name + ':', "OK"
                break
            elif read == "":
                print 'buit'
                time.sleep(2)
            else:
                break
            time.sleep(2)      
     return read
    
  #Funció per el tancament del socket en cas d'interrupció del programa
  def close(self):
    self.netcat.shutdown(socket.SHUT_RD)
    self.netcat.close()

    
#Principal#####################################################################

#Definició del modem amb la IP, el port de comunicació i el nom (crida de la
#classe netcat)    
modem3 = netcat(HOSTNAME2,PORT2,'modem3')

#Bucle infinit principal 
while 1:    
    numbytesaux = ""
    #Bucle per l'espera del numero de bytes a rebre amb el flag "#"
    while 1:
        numbytesaux = modem3.port_read()
        z = numbytesaux.find("#")
        if z!= -1:
            numbytesaux = numbytesaux.replace("#","")
            tempsImatge = time.time()
            break
    
    numbytesaux1 = numbytesaux.split(",")
    numbytes = int(numbytesaux1[-1])
    print "El numero de bytes de la imatge son: "+str(numbytes)
    
    #Es contesta si es rep o no el número de bytes de la imatge
    if numbytesaux1 != "":
        print ("Enviem la correcta recepcio del nombre de bytes de la imatge"+
        " a rebre")
        modem3.send('AT*SEND,2,2,OK')

    acc = ""
    #Llegim la imatge fins a trobar la exclamació que indica el final o el flag
    # del "$" corresponent a la interrupció de la recepció
    sortir = 0
    while 1:
              Imatge = modem3.port_read()
              x1 = Imatge.find("!")
              x2 = Imatge.find("$")
              if x2!=-1:
                  sortir=1
                  print ("S'ha detingut la recepció d'imatges a causa d'un"+
                  " error en l'enviament de les imatges, pero s'ha solucionat")
                  break
              if x1!=-1:
                  acc = acc+Imatge.replace("!","")
                  break
              else:
                  acc = acc+Imatge
      
    #Es realitza un split per salts de línies per tal de separar els missatges
    #i les notificacions en cas de no haver detectat l'error anterior     
    if sortir != 1:
        Imatgeaux = acc.splitlines()
        mida= len(Imatgeaux)
        aux2 = 1
        i = 1
        ImatgeNova = ""
        #Es separen les diferents línies amb comes per el posterior tractament
        while i<mida:
            if aux2 == 1:
                ImatgeNova = ImatgeNova + Imatgeaux[0]
                aux2 = 0
            ImatgeNova = ImatgeNova + ',' + Imatgeaux[i]
            i=i+1
        #Es realitza un altre split per comes i s'elimina la informació dels 
        #"DELIVERED" o "FALSE" els quals no aporten informació 
        ImatgeNova2 = ImatgeNova.split(",")
        #Es busquen tots els "RECV" que precedeixen a la información del 
        #missatge i s'eliminen (la capçalera)
        m = [u for u, x in enumerate(ImatgeNova2) if x == "RECV"]
        i=0
        ImatgeDef = ""
        while i<len(m):
            #S'agafen 9 posiciones més ja que el missatge es troba 9 posicions
            #més endevant del "RECV"
            ImatgeDef = ImatgeDef + ImatgeNova2[m[i]+9] 
            i=i+1
            
        #Es comprova si la imatge rebuda té el mateix número de bytes que
        #l'original i es guarda en una carpeta amb la data actual
        if len(ImatgeDef) == numbytes:
            modem3.send('AT*SEND,2,2,OK')    #Es contesta amb un OK
            print "La imatge ha sigut rebuda correctament"
            dir = os.path.dirname(__file__)
            save_path  = dir+'/'+str(datetime.date.today())
            try:
                os.stat(save_path)
            except:
                os.mkdir(save_path)
            fitxer = os.path.join(save_path, str(tempsImatge)+".jpg")    
            fh=open(fitxer,"wb")
            fh.write(ImatgeDef.decode('base64'))
            fh.close
        
        else:   
            modem3.send('AT*SEND,2,2,KO')
            print "La imatge no ha sigut rebuda correctament"
                    
                    