# -*- coding: utf-8 -*-
"""
Created on Sat Feb 16 13:40:41 2019

@author: Oriol Solé

Programa versió2: Enviament d'imatges configurable (Programa modem receptor)
"""

#Llibreries####################################################################

#Importacio de les llibreries adients:
import base64   #Llibreria per codificar i descodificar les imatges en base 64
import socket   #Llibreria per fer ús dels sockets
import time     #Llibreria per manipular tasques relacionades amb temps
import datetime #Llibreria per obentir dates
import os       #Llibreria per manipular paths
import sys      #Llibreria per executar instruccions amb permis del sistema

#Configuració Modems###########################################################

#Definicio de les IPs i dels ports de comunicació dels modems acustics físics 
#i virtuals receptors
HOSTNAME2EM = '10.42.57.3'
HOSTNAME2 = '192.168.1.197'
PORT2 = 9200
condicioaux = 0
#Classe funcions sockets#######################################################

#Creacio de la classe netcat per ubicar les funcions relatives a la manipulacio
#dels sockets
class netcat(object):
    #Definició de la funció inicial per la configuració del mòdem acústic
    def __init__ (self,hostname,port,modem_name):
        #Establiment de la ip, el port de comunicació i el nom del mòdem
        self.ip = hostname
        self.port = port
        self.name = modem_name
        #Creació del socket i connectivitat
        try:
            self.netcat = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.netcat.settimeout(0.1)
            self.netcat.connect((self.ip, self.port))
        except:
            print ("El programa es tancara, ja que no s'ha pogut establir una"+
            "connexio degut a que el sistema no esta alimentat, connecti la"+
            "alimentacio i executi de nou el programa")
            time.sleep(5)
            sys.exit(1)
        
        #Comprovar si s'ha rebut el flag "$" mentres el programa estava tancat
        #abans de reiniciar el buffer de transmissió
        global condicioaux
                
        resposta_aux = self.port_read()
        if resposta_aux[1] == 1:
            condicioaux = 1

        #Configuracions inicials:
        print 'Activacio permissos'
        self.send('AT@CTRL')
        print 'Desactivacio notificacions extesses'
        self.send('AT@ZX0')
        print 'Desactivacio notificacions de posicionament'
        self.send('AT@ZU0')
        print 'Reiniciament del buffer de transmissio:'
        self.send('ATZ4')
        print 'Configuracio del numero de bytes del buffer de transmissio:'
        self.send('AT@ZL1000000')
        print 'Guardar en memoria les configuracions del modem'
        self.send('AT&W') 
    
    #Funció de lectura de dades 
    def port_read(self):
        buff = ''
        aux = 0
        read = ''
        while 1:
            #Bloc d'excepcio, en cas de no poder establir connectivitat, i que
            #no es tracti d'un error de timeout, es torna a intentar restablir
            #la connexio perduda
            try:
                read = self.netcat.recv(1)
            except socket.error as error:
                if str(error) != "timed out":
                    print ("El programa es tancara degut a un problema amb la"+
                    " alimentacio, comprovala i executa de nou el programa")
                    time.sleep(5)
                    sys.exit(1)
                    break
                break
            if read:
              buff += read
              #S'observa si mentres s'ha llegit el buffer del mòdem, paral·lela
              #-ment s'ha rebut el flag "$"
              valor = read.find("$")
              if valor!=-1:
                aux = 1
            else:
                break
        return buff,aux
            
    #Funció per escriptura de comandes AT
    def port_write(self,command):
       while 1:
           print 'Send',self.name +':',command
           try:
               self.netcat.sendall(command + '\n')
               break
           except:
               try:
                   self.netcat = socket.socket(socket.AF_INET, 
                   socket.SOCK_STREAM)
                   self.netcat.settimeout(0.1)
                   self.netcat.connect((self.ip, self.port))
                   print "Connexio recuperada"
               except:
                   print "Intent de connexio fallit"
                   time.sleep(2)
                   pass
       return
   
    #Funció d'enviament de comandes AT amb comprovació de resposta
    def send(self,command):
        while 1:
            try:
                self.port_write(command)
                read = self.port_read()
                x1 = read[0].find("BUSY CLOSING CONNECTION")
                x2 = read[0].find("FAILED")
                x3 = read[0].find("OK")
                if x1!=-1:
                    print "Received", self.name + ':', "FAILED"
                elif x2!=-1:
                    print "Received",self.name + ':', "BUSY CLOSING CONNECTION"
                elif x3!=-1: 
                    print "Received",self.name + ':', "OK"
                    break
                elif read[0] == "":
                    print 'buit' 
                    time.sleep(2)
                else:
                    break
            except:
                break;
            time.sleep(2)
        return read[0],read[1]
    
    #Funció per el tancament del socket en cas d'interrupció del programa
    def close(self):
        self.netcat.shutdown(socket.SHUT_RD)
        self.netcat.close()


#Funcions######################################################################
        
#Funció basada en el programa "Read_PC", la qual se li ha de passar com a 
#parametres, el directori en el qual ha de guardar la imatge
def Read_Foto(save_pathSerien):
    numbytesaux = ""
    aux = 0
    #Bucle per l'espera del numero de bytes a rebre amb el flag "#"
    while 1:
        numbytesaux = modem3.port_read()
        #Si es troba el flag "$" es retorna el valor auxiliar dat, per indicar
        #la recepció de la finalització de la captura i enviament de les 
        #imatges per part del modem transmissor
        z = numbytesaux[0].find("#")
        if z!= -1 and numbytesaux[1] == 1:
            aux=1 
            return aux
        elif z!=-1:
            numbytesaux = numbytesaux[0].replace("#","")
            tempsImatge = time.time()
            break
        elif numbytesaux[1] == 1:
            aux = 1
            return aux
    
    numbytesaux1 = numbytesaux.split(",")
    numbytes = int(numbytesaux1[-1])
    print "El numero de bytes de la imatge son: "+str(numbytes)
    time.sleep(2)
    
    #Es contesta si es rep o no el número de bytes de la imatge  
    if numbytesaux1 != "":
        print ("Enviem la correcta recepcio del nombre de bytes de la imatge"+
        " a rebre")
        modem3.send('AT*SEND,2,2,OK')
                
    acc = ""
    sortir = 0
    #Llegim la imatge fins a trobar la exclamació que indica el final o el flag
    # del "$" corresponent a la interrupció
    while 1:
          Imatge = modem3.port_read()
          x1 = Imatge[0].find("!")
          if Imatge[1] == 1:
              sortir=1
              return sortir
          if x1!=-1:
              acc = acc+Imatge[0].replace("!","")
              break
          else:
              acc = acc+Imatge[0]
          
    #Es realitza un split per salts de línies per tal de separar els missatges
    #i les notificacions 
    Imatgeaux = acc.splitlines()
    mida = len(Imatgeaux)
    aux2 = 1
    i = 1
    ImatgeNova = ""
    #Es separen les diferents línies amb comes per el posterior tractament
    while i<mida:
        if aux2 == 1:
            ImatgeNova = ImatgeNova + Imatgeaux[0]
            aux2 = 0
        ImatgeNova = ImatgeNova + ',' + Imatgeaux[i]
        i=i+1
    
    #Es realitza un altre split per comes i s'elimina la informació dels 
    #"DELIVERED" o "FALSE" els quals no aporten informació 
    ImatgeNova2 = ImatgeNova.split(",")
    
    #Es busquen tots els "RECV" que precedeixen a la información del 
    #missatge i s'eliminen (la capçalera)
    m = [u for u, x in enumerate(ImatgeNova2) if x == "RECV"]
    i=0
    ImatgeDef = ""
    while i<len(m):
        #S'agafen 9 posiciones més ja que el missatge es troba 9 posicions
        #més endevant del "RECV"
        ImatgeDef = ImatgeDef + ImatgeNova2[m[i]+9] 
        i=i+1
        
    #Es comprova si la imatge rebuda té el mateix número de bytes que
    #l'original i es guarda en una carpeta amb la data actual
    if len(ImatgeDef) == numbytes:
        modem3.send('AT*SEND,2,2,OK')    #Se contesta con un OK
        print "La imatge ha sigut rebuda correctament"
        time.sleep(5)

        try:
            os.stat(save_pathSerien)
        except:
            os.mkdir(save_pathSerien)
        
        fichero = os.path.join(save_pathSerien,str(tempsImatge)+".jpg")    
        fh=open(fichero,"wb")
        fh.write(ImatgeDef.decode('base64'))
        fh.close
    
    else:    
        modem3.send('AT*SEND,2,2,KO')
        print "La imatge no ha sigut rebuda correctament"
        time.sleep(5)
                    
#Principal#####################################################################

#Definició del modem amb la IP, el port de comunicació i el nom (crida de la
#classe netcat)        
modem3 = netcat(HOSTNAME2,PORT2,'modem3')

#Obtencio del path on s'ubica el programa i creació de directoris per ubicar
#les diferents peticions de series d'imatges que l'usuari demana  
dir = os.path.dirname(__file__)
save_pathGlobal = dir+'/Results'

try:
    os.stat(save_pathGlobal)
except:
    os.mkdir(save_pathGlobal)

save_pathGlobalFotos = save_pathGlobal+'/Series'

try:
    os.stat(save_pathGlobalFotos)
except:
    os.mkdir(save_pathGlobalFotos)

#Bucle infinit principal 
while 1:
    #Creació d'un fitxer de text per tal de guardar el número de serie pel qual
    #es va, per disposar-lo en memòria en cas de tancament del programa
    fitxerserie = os.path.join(save_pathGlobal,"NumeroSerie.txt")
    respostax = os.path.exists(fitxerserie)
    #En cas de no existir, es crea i es comença amb la primera serie
    if respostax == False:
        fh = open(fitxerserie,"w")
        fh.write("1")
        fh.close()
        nserie = 1
    #Si existeix, s'obre es llegeix i es continua amb la serie indicada
    else:
        fh = open(fitxerserie,"r")
        nseriex = fh.read()
        fh.close()
        nserie = int(nseriex)
    #Si existien imatges que havien sigut demanades anteriorment, i a causa del
    #tancament del programa no es van poder rebre totes,es dona l'opció de 
    #continuar amb la recepció de les mateixes, o cancelar-les. Sino,es 
    #comença una nova serie
    fitxerfotos = os.path.join(save_pathGlobal,"FotosPrevistes.txt")
    resposta = os.path.exists(fitxerfotos)
    #Començament serie nova: Nfotos a capturar, resolucio i qualitat
    if resposta == False:
        while 1:
            fotos = raw_input("Introdueix el numero de fotos a capturar: ")
            numero = fotos.isdigit()
            if numero == True:
                Nfotos = int(fotos)
                if Nfotos>0:
                    break
                else:
                    print "El proposit del programa es capturar imatges..."
            else:
                print "El valor no és vàlid"

        while 1:
            resolucioaux = raw_input("Introdueix la resolucio: ")
            x1=resolucioaux.find("640x480")
            x2=resolucioaux.find("720x480")
            x3=resolucioaux.find("1280x720")
            if x1!=-1 or x2!=-1 or x3!=-1:
                break
            else:
                print "El valor no és vàlid"
        resolucio = resolucioaux.split("x")
        
        while 1:
            qualitat = raw_input("Introdueix la qualitat d'imatge: ")
            numero = qualitat.isdigit()
            qualitat = int(qualitat)
            if numero == True and qualitat>0 and qualitat<=100:
                break
            else:
                print "El valor no es valid"
        
        #Es guarda el número de fotos previstes a capturar, per si es produeix
        #un tancament del programa
        fh = open(fitxerfotos,"w")
        fh.write(fotos)
        fh.close()
        
        info = ""
        info=str(Nfotos)+","+resolucio[0]+","+resolucio[1]+","+str(qualitat)
        time.sleep(2)
        
        #S'envia la informació del numero de fotos, resolucio i qualitat
        modem3.send('AT*SEND,'+str(len(str(info))+1)+',2,'+info+'!')
        #S'executa la funció de llegir tantes vegades com nfotos hi hagi
        #Si el modem transmissor falla, es detecta a partir del flag "$"
        NumeroFotos = 0
        save_pathSerien = save_pathGlobalFotos+'/'+str((str(nserie)).zfill(4))\
        +'_'+str(datetime.date.today())
        while NumeroFotos<Nfotos:
            sortir = Read_Foto(save_pathSerien)
            if sortir==1:
                print ("Hi ha hagut un error en el modem transmissor, pero"+
                " s'ha restablert")
                break
            NumeroFotos=NumeroFotos+1    
        while 1:
            valor = modem3.port_read()
            if valor[1] == 1 or sortir == 1:
                os.remove(save_pathGlobal+'/FotosPrevistes.txt')
                nserie = nserie+1
                fh = open(fitxerserie,"w")
                fh.write(str(nserie))
                fh.close()
                break       
     
    #Si existien fotos previstes, primer es comprova si el modem ja les havia
    #enviat, i sino es permet la opcio de seguir rebent-les o cancelar-les
    elif resposta == True:
        valor = modem3.port_read()
        if valor[1] == 1:
            os.remove(save_pathGlobal+'/FotosPrevistes.txt')
            nserie = nserie+1
            fh = open(fitxerserie,"w")
            fh.write(str(nserie))
            fh.close()

        else:    
            
            fh = open(fitxerfotos,"r")
            nfotos = fh.read()
            fh.close()
            r = 0
            z=0
            condicio2 = 0
            while 1:
                Delete = raw_input("Tens "+nfotos+" fotos previstes de" +
                " capturar, vols cancerlar-les (1) o seguir igual (0): ")
                #Si es volen seguir rebent:
                if Delete == "0":
                    condicio = 0
                    print ("Es procedeix a seguir rebent les imatges"+
                           " comprovant l'estat del modem")
                    while 1:
                        #Es comprova l'estat del modem, per veure si l'altre 
                        #modem ja ha finalitzat, ha enviat el flag, pero 
                        #el modem receptor estava desconnectat, i per tant,
                        #no ha pogut rebre el flag
                        while 1:
                            respostax = modem3.send("AT?S")
                            #Si el modem no es troba online, significa que el
                            #modem transmissor ja ha acabat l'enviament de les
                            #imatges
                            x1 = respostax[0].find("INITIATION LISTEN")
                            if respostax[1] == 1:
                                condicio2 = 1
                                break
                            
                            if x1!=-1:
                                z=z+1
                                time.sleep(2)
                                if z==10:
                                    condicio2 = 1
                                    break
                            else:
                                break
                        
                        #s'eliminen les fotos previstes, en cas d'haver acabat
                        #l'enviament el modem transmissor
                        valor = modem3.port_read()
                        if (valor[1]== 1 or condicio == 1 or condicio2 == 1 
                            or condicioaux == 1):
                            os.remove(save_pathGlobal+'/FotosPrevistes.txt')
                            print("Les imatges ja han estat capturades i"+
                            " processades")
                            break  
                        #sino es torna a llegir el numero de bytes de la imatge
                        #seguent
                        save_pathSerien = save_pathGlobalFotos+'/'\
                        +str((str(nserie)).zfill(4))+'_'\
                        +str(datetime.date.today())
                        condicio = Read_Foto(save_pathSerien)
                    nserie = nserie+1
                    fh = open(fitxerserie,"w")
                    fh.write(str(nserie))
                    fh.close()
                    break
                #Si es volen eliminar les imatges, primer es comprova com en
                #l'altre cas, si el modem ja ha finalitzat l'enviament
                elif Delete == "1":
                    while 1:
                        i=0
                        aux2 = 0
                        while i<10:
                            valor= modem3.port_read()
                            if valor[1]== 1 or condicioaux == 1:
                                os.remove(save_pathGlobal+
                                '/FotosPrevistes.txt')
                                print("La captura de imatges ha sigut"+
                                " detinguda")
                                aux2=1
                                break
                            i=i+1
                        aux = 1
                        if aux2== 1:
                            break
                        #Per tal d'assegurar la finalitzacio de la captura es
                        #comprova tant l'estat del modem, com s'envia un flag
                        #"@" per tal de comunicar al modem la finalitzacio de 
                        #la serie
                        while 1:
                            aux4=0
                            respostax = modem3.send("AT?S")
                            x1 = respostax[0].find("INITIATION LISTEN")
                            if x1!=-1:
                                aux4=1
                            if respostax[1]== 1:
                                aux4 = 1
                            print ("Es procedeix a comunicar al modem" +
                            " transmissor la cancelacio del enviament de les"+
                            " imatges")
                            resposta = modem3.send('AT*SEND,1,2,@')
                            time.sleep(5)
                            if resposta[1] == 1:
                                aux4=1
                                
                            valor2 = modem3.port_read()
                            if valor2[1] == 1 or aux4==1 or condicioaux==1:
                                os.remove(save_pathGlobal+
                                '/FotosPrevistes.txt')
                                time.sleep(10)
                                print("La captura de imatges ha sigut"+
                                " detinguda")
                                break  
                        break 
                    nserie = nserie+1
                    fh = open(fitxerserie,"w")
                    fh.write(str(nserie))
                    fh.close()
                    break
                else:
                    print("El valor introducido no es valid, torna a" +
                    " introduir-lo: ")
                    
modem3.close()                  